;;; -*- Mode: LISP; Syntax: Common-lisp; Package: QPE -*-

(in-package 'QPE)

;;;; Performance tuning for QPE

;;; Assumes the ACCOUNTS system

(defun general-charges ()
  (user::install-charges '((envision)
			   (expand-scenario)
			   (install-qc-pc-assumptions)
			   (resolve-influences)
			   (limit-analysis)
			   (construct-Sclasses))))

(defun remove-general-charges ()
  (user::remove-charges '((envision)
			   (expand-scenario)
			   (install-qc-pc-assumptions)
			   (resolve-influences)
			   (limit-analysis)
			   (construct-Sclasses)
			   (run-qpe-events))))

(defun charge-ir ()
  (user::install-charges '((resolve-all-direct-influences)
			   (resolve-all-indirect-influences)
			   (construct-uninfluenced-justification)
			   (add-unambiguous-Ds-information)
			   (resolve-ambiguous-ds-values)
			   (expand-derived-qstate-by-derivatives))))

(defun uncharge-ir ()
  (user::remove-charges '((resolve-all-direct-influences)
			   (resolve-all-indirect-influences)
			   (construct-uninfluenced-justification)
			   (add-unambiguous-Ds-information)
			   (resolve-ambiguous-ds-values)
			   (expand-derived-qstate-by-derivatives))))

(defun charge-la ()
  (user::install-charges '((augment-derivative-comparisons)
			   (index-situations)
			   (find-single-change-limit-hypotheses)
			   (apply-lhs-to-situations)
			   (generate-conjunctive-limit-hypotheses)
			   (find-next-states)
			   (prune-via-continuity)
			   (prune-via-closest)
			   (apply-equality-change-law)
			   (install-duration-information)
			   (unsimplify-lh-envs)
			   (prune-asymptotic-approach-states))))